#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define MAXN 250
#define CHROM 31
#define ENDTIME 4.90
#define COMRATE 3

class Point
  {
    public:
      int x,y;
  } points[MAXN];

class CPath
  {
    public:
    short path[MAXN];
    int good;
    CPath()
      {for(int i=0;i<MAXN;i++) path[i]=0;good=0;}
    void CalcGood(int n)
      {
        good=0;
        path[n]=path[0];
        for(int i=0;i<n;i++)
          good+=Dist(path[i],path[i+1]);
      }
    void print(int n)
      {
        for(int i=0;i<n;i++) printf((i==n-1)?("%d\n"):("%d "),path[i]+1);
//        printf("Length : %d\n",good);
      }
    private:
      int Dist(int p1,int p2)
        {return abs(points[p1].x-points[p2].x)+abs(points[p1].y-points[p2].y);}
  } paths[CHROM];

int n;
float tm;

int cmp(CPath *a,CPath *b)
  {
    return a->good-b->good;
  }

void Init()
  {
//    FILE *f=fopen("travel.in","rt");
    fscanf(stdin,"%d",&n);
    for(int i=0;i<n;i++)
      fscanf(stdin,"%d%d",&points[i].x,&points[i].y);
//    fclose(f);
  }

void GenerateInitials()
  {
    short visited[MAXN];
    short pos,k,l;
    for(int i=0;i<CHROM;i++)
      {
        memset(visited,0,sizeof(visited));
        srandom(time(0)+random()*random());
        for(int j=0;j<n;j++)
          {
            pos=random()%n+1;
            l=0;k=0;
            while(666)
              {
                if(!visited[l] && k+1==pos) break;
                else if(!visited[l]) k++;
                l++;
                if(l==n) l=0;
              }
            paths[i].path[j]=l;
            visited[l]=1;
          }
        paths[i].CalcGood(n);
      }
  }

void Combine(CPath &p1,CPath &p2)
  {
    int cutpos=random()%(n-1)+1;
    int tmp;
    CPath tmpp=p1;
    short visited[MAXN];
    memset(visited,0,sizeof(visited));
    for(int i=0;i<cutpos;i++) visited[p1.path[i]]=1;
    for(int i=cutpos;i<n;i++)
      if(visited[p2.path[i]])
        {
          tmp=0;
          while(visited[tmp])tmp++;
          p1.path[i]=tmp;
          visited[tmp]=1;
        }
      else
        {
          visited[p2.path[i]]=1;
          p1.path[i]=p2.path[i];
        }
    memset(visited,0,sizeof(visited));
    for(int i=0;i<cutpos;i++) visited[p2.path[i]]=1;
    for(int i=cutpos;i<n;i++)
      if(visited[tmpp.path[i]])
        {
          tmp=0;
          while(visited[tmp])tmp++;
          p2.path[i]=tmp;
          visited[tmp]=1;
        }
      else
        {
          visited[tmpp.path[i]]=1;
          p2.path[i]=tmpp.path[i];
        }
    p1.CalcGood(n);
    p2.CalcGood(n);
  }

void Optimize()
  {
    int used[CHROM];
    int pos;
    tm=(float)clock()/CLOCKS_PER_SEC;
    qsort(paths,CHROM,sizeof(paths[0]),cmp);
    while(tm<ENDTIME)
      {
        qsort(paths,CHROM,sizeof(paths[0]),cmp);
        memset(used,0,sizeof(used));
        used[0]=1;
        for(int i=1;i<CHROM;i++)
          if(!used[i])
            {
              used[i]=1;
              for(pos=0;pos<CHROM;pos++)
                  if(!used[pos] && random()%COMRATE)
                    {
                       Combine(paths[i],paths[pos]);
                       used[i]=used[pos]=1;
                    }
            }
        tm=(float)clock()/CLOCKS_PER_SEC;
      }
  }

void Output()
  {
    paths[0].print(n);
  }

void main()
  {
    Init();
    clock();
    GenerateInitials();
    Optimize();
    Output();
  }
