#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define ABS(x) (((x) >= 0) ? (x) : ((-1)*(x)))

int best_dist;
int best[200];
int visited[200];

int n;
int adj[200][200];
int sort_adj[200][200][2];
int x[200], y[200];

clock_t t1;

void search_sort() {
     register int *i;
     register int *node;
     register int *sum;
     int *end;

     int i_arr[210];
     int node_arr[210];
     int sum_arr[210];

     i = i_arr;
     end = i + n;
     node = node_arr;
     sum = sum_arr;

     *i = 1;
     *node = 0;
     *sum = 0;

     do {
           while (*i != n && visited[sort_adj[*node][*i][1]])
                 i[0]++;
          if (*i == n) {
                 visited[*node] = 0;
                 if (*sum)
                    break;
                 i--, node--, sum--;
                 continue;
           }

           sum++;
           *(node + 1) = sort_adj[*node][*i][1];
           *sum = *(sum - 1) + sort_adj[*node][*i][0];
           i[0]++;

           node++;
           i++;

           visited[*node] = 1;
           *i = 1;

           if (visited[0]) {
              if (i == end)
                 if (best_dist > *sum) {
                   best_dist = *sum;
                   memcpy(best, node_arr, sizeof(int)*n);
                 }
              visited[*node] = 0;
              i--, node--, sum--;
           }

           if (clock() - t1 > 3*CLOCKS_PER_SEC)
              break;
     } while (1);
}

int a_sum = 0;
int list[210][210];
int way[210];
int depth = 0;

#define NEXT    list[depth][i]
void randomize_list(int depth) {
     int i, j, t;

     for (i = 0; i < n; i++)
         NEXT = i;
     for (i = 0; i < n; i++) {
         j = rand()%n;
         t = NEXT;
         NEXT = list[depth][j];
         list[depth][j] = t;
     }
}

void semi_random_sort(int node) {
     int i;

     if (depth == n) {
        a_sum += adj[way[depth - 1]][0];
        if (best_dist > a_sum) {
           best_dist = a_sum;
           memcpy(best, way, sizeof(int)*n);
        }
        a_sum -= adj[way[depth - 1]][0];
        return;
     }
     randomize_list(depth);
     for (i = 0; i < n; i++)
         if (!visited[NEXT] && (depth == n - 1 || NEXT != 0)) {
            visited[NEXT] = 1;
            way[depth + 1] = NEXT;
            a_sum += adj[node][NEXT];
            depth++;
            semi_random_sort(NEXT);
            if (clock() - t1 > 48*CLOCKS_PER_SEC/10)
                return;
            depth--;
            a_sum -= adj[node][NEXT];
            visited[NEXT] = 0;
         }
}

void found() {
     int i;

     for (i = 0; i < n; i++)
         printf("%s%i", i ? " " : "", best[i] + 1);
     printf("\n");
}

int fcmp(const void *e1, const void *e2) {
    return *(int *)e1 - *(int *)e2;
}

int main() {
    int i, j;

    best_dist = 0x7FFFFFFF;
    t1 = clock();
    scanf("%i", &n);
    for (i = 0; i < n; i++) {
        scanf("%i %i", x + i, y + i);
        for (j = 0; j < i; j++)
            adj[i][j] = adj[j][i] = ABS(x[i] - x[j]) + ABS(y[i] - y[j]);
    }

    for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++) {
            sort_adj[i][j][0] = adj[i][j];
            sort_adj[i][j][1] = j;
        }
        qsort(sort_adj[i], n, 2*sizeof(int), fcmp);
    }

    memset(visited, 0, sizeof(int)*n);
    search_sort(); //stop at the 3rd second

    way[0] = 0;
    memset(visited, 0, sizeof(int)*n);
    srand(437); //not random actually
    semi_random_sort(0); //stop at the 4.8th second

    found();

    return 0;
}

