/* INCLUDES *****************************************************************/
   #include <iostream>
   #include <cstdlib>

   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
   int const c_bf = 10;
   int cbf[] = { 1, 1, 2, 6, 24, 120, 720, 5040, 40320, 362880, 3628800, 39916800 };

/* CLASSES ******************************************************************/
   class point
   {
   public:
      point() {}
      point(point const& _p): x(_p.x), y(_p.y) {}
      point& operator = (point const& _p)
      {
         x = _p.x;
         y = _p.y;
         return *this;
      }
      ~point() {}

      int dist(point const& _p) const
      {
         return abs(x - _p.x) + abs(y - _p.y);
      }

      int x;
      int y;
   };

/* GLOBALS ******************************************************************/
   int n;
   point ps[202];

   long long best = 999999999;
   int ans[202];

   int tmp[202];

   int i_tmp_res;
   int tmp_res[202][202];

   /* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      for (int i = 1; i < n; ++i)
         cout << ans[i] << ' ';
      cout << ans[n] << endl << flush;

      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> n;
      for (int i = 1; i <= n; ++i)
      {
         int x;
         int y;
         cin >> x >> y;
         ps[i].x = x;
         ps[i].y = y;
      }
   }
/****************************************************************************/
   void fill(int pos)
   {
      if (pos > n)
      {
         for (int i = 1; i <= n; ++i)
            tmp_res[i_tmp_res][i] = ans[i];
         tmp_res[i_tmp_res][n + 1] = 1;
         ++i_tmp_res;
         return;
      }

      int i_min;
      int c_min = 999999;
      for (int i = 1; i <= n; ++i)
         if (tmp[i] == 0)
            if (ps[ans[pos - 1]].dist(ps[i]) < c_min)
            {
               i_min = i;
               c_min = ps[ans[pos - 1]].dist(ps[i]);
            }

      ans[pos] = i_min;
      tmp[i_min] = 1;

      fill(pos + 1);

      tmp[i_min] = 0;
   }
/****************************************************************************/
   void run()
   {
      if (n <= c_bf)
      {

         for (int i = 1; i <= n; ++i)
            tmp[i] = i;
         tmp[n + 1] = 1;

         do
         {
            long long res = 0;
            for (int c = 1; c <= n; ++c)
               res += ps[tmp[c]].dist(ps[tmp[c + 1]]);

            if (res < best)
            {
               best = res;
               for (int d = 1; d <= n; ++d)
                  ans[d] = tmp[d];
            }

         }
         while (next_permutation(tmp + 2, tmp + n + 1));

         done();
      }

      for (int i = 0; i < 202; ++i)
         tmp[i] = 0;
      i_tmp_res = 0;

      ans[1] = 1;
      tmp[1] = 1;

      for (int i = 2; i <= n; ++i)
      {
         ans[2] = i;
         tmp[i] = 1;
         fill(3);
         tmp[i] = 0;
      }

      best = 999999;
      for (int i = 0; i < i_tmp_res; ++i)
      {
         int res = 0;
         for (int j = 1; j <= n; ++j)
            res += ps[tmp_res[i][j]].dist(ps[tmp_res[i][j + 1]]);

         if (res < best)
         {
            best = res;
            for (int j = 1; j <= n; ++j)
               ans[j] = tmp_res[i][j];
         }
      }
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();
      return 0;
   }
/****************************************************************************/

